#!/usr/bin/perl
# lslRF.pl
#  Make a ls-R like file that contains the directory structure.
#
# Copyright 1999 Jim Hefferon
#  This program can redistributed and/or modified under the terms
#   of the LaTeX Project Public License Distributed from CTAN
#   archives in directory macros/latex/base/lppl.txt; either
#   version 1 of the License, or (at your option) any later version.
#
# HISTORY
#  1999-Jun-04 Jim Hefferon tex@joshua.smcvt.edu Written.
#       Jun-14 JH Now makes one-directory-per-line to speed file searching
$mode="outside";  # either outside or inside a directory listing
$currentdir="tex-archive";

# Read lines from the standard input and expect them to
# conform to the format of ls-lRF
while ($line=<STDIN>) {
     if (($mode eq "outside") && ($line=~/^(.*:)/)) { # directory ends in :
         $mode="inside"; # inside directory listing
         print "$1";   # includes the : as separator
     } elsif (($mode ne "collect") && ($line=~/^total/)) {
         if ($mode eq "outside") { # first line sometimes not there
	     print "$currentdir:";
         }  
         $mode="collect"; # next will collect the file, subdir, and link names
     } elsif (($mode eq "collect") && ($line=~/^\s*$/)) { # blank line
         print "\n"; # separates directory listings
         $mode="outside"; 
     } else { # these are now the lines of interest; five junk fields first
         if ($line=~/(\S*\s*){5}(\S*\s*\S*\s*\S*)\s*(\S.*)/) {
             print "$3($2)";  # filename (with link perhaps) and date
         } else {
            die "i'm confused: $line"
         }
     }
}
