#!/bin/sh
# check_mirrors.sh
#  See which mirrors are awake, and have the capacities of .zip and .tar.gz
#
# 2000-Nov-13 Jim Hefferon ftpmaint@tug.ctan.org
# 2001-Mar-08   Added conversion to change `ctan.tug.org' to `tug.ctan.org'
#          09   Added mail notification if fetch fails

CTANSITES=/home/ftp/pub/tex-archive/CTAN.sites
AWKSCRIPT=/home/ftpmaint/check_mirrors/mirrors_to_check.awk
FETCHDATAIN=/home/ftpmaint/check_mirrors/mirrors.txt
FETCH=/home/ftpmaint/check_mirrors/fetch.pl
FETCHDATAOUT=/home/ftpmaint/check_mirrors/responding_mirrors.txt
CONVERTTUGADDRESS=/home/ftpmaint/check_mirrors/ctan_tug-to-tug_ctan.awk

AWK=/bin/awk
MV=/bin/mv
CP=/bin/cp
CHOWN=/bin/chown
CHMOD=/bin/chmod

$AWK -f$AWKSCRIPT <$CTANSITES >$FETCHDATAIN.new
if [ -e $FETCHDATAIN.new ]; then
    $MV $FETCHDATAIN.new $FETCHDATAIN
    $CHOWN ftpmaint:ctan $FETCHDATAIN
    $CHMOD ug+rw $FETCHDATAIN
else
    echo "unable to make fetch input datefile"
fi

if $FETCH --sitelist=$FETCHDATAIN --resultlist=$FETCHDATAOUT.new
then
    if [ -e $FETCHDATAOUT.new ]; then
	$AWK -f$CONVERTTUGADDRESS <$FETCHDATAOUT.new >$FETCHDATAOUT.converted
	$MV $FETCHDATAOUT.converted $FETCHDATAOUT
	$CHOWN ftpmaint:ctan $FETCHDATAOUT
	$CHMOD ug+rw $FETCHDATAOUT
    else
	echo "no output from fetch"
	exit 1
    fi
else
    echo "check_mirrors.sh: fetch failed"
    echo "check_mirrors.sh: fetch failed" | mail ftpmaint 
fi
