package Apache::Contacts;
# File: Apache/Contacts.pm

use strict;

use Apache::Constants qw(:common);
use CGI qw(:all);
use Apache::CTAN;

# all variables global to stop memory/GC buildup?
use vars qw(%cookie_data %param_data %except);
%cookie_data = ();
%param_data = ();
%except = (    # Do not include in the lists of params (e.g. in URL_str) 
		  );
use vars qw($header $redirect_flag $URL_str);
$header = "";  # http header that will be sent
$redirect_flag = 0; # should redirect to another page?
$URL_str = "";  # params as URL fields for a GET link

# Variable needed here, but not other modules
use vars qw($this_mods_URL $mirror);
$this_mods_URL = CONTACTS_PAGE(); # URL from perl.conf for this module  
$mirror = "";

use vars qw($r); # request object

sub handler {
    $r = shift;
    # blank out cross-process data
    %cookie_data = ();
    %param_data = ();
    %except = (
	       );
    # handle http headers
    $param_data{PARAM_ACTION_KEY()} = $this_mods_URL;
    ($header,$redirect_flag) = CTAN_header($this_mods_URL,0,\%cookie_data,\%param_data); 
    $r->print(
	      $header
	      );
    if ($redirect_flag) {
	return OK;
    }
    $URL_str = params_as_URLfields(%cookie_data,%param_data);
    #$mirror = $param_data{PARAM_MIRROR_KEY()};
    $param_data{PARAM_NEWMIRRORFLAG_KEY()} = 0;
    # done with the header & state stuff

    $r->print(
	      start_html(-title => "CTAN administrative contact information",
			 -meta=>{'keywords'=>META_KEYWORDS()}),
	      h2("CTAN administrative contact information")
	      );

    $r->print(
	      p(
		"Here you can send questions or comments 
                 about the administration of this site or of 
                 the Comprehensive TeX Archive Network in general.
                 Please do not send questions about TeX; if you have such a
                 question a good place to look is the ",
		a({-href=>STARTER_PAGE()."$URL_str"},
		  "TeX starter"),
		" page. "
		)
	      );

    $r->print(
	      p(
		ul(
		   li(
		      i("Messages about this site"),
		      " should go to the ",
		      a({-href=>"mailto:ftpmaint\@alan.smcvt.edu"},
			"site administrator"),
		      ". "
		      ),
		   li(
		      i("Messages about CTAN in general"),
		      " are best sent to the ",
		      a({-href=>"mailto:ctan\@dante.de"},
			"CTAN mail list"), 
		      ". ",
		      "This includes offers to join the ",
		      a({-href=>WEBFTP_ROOT()."CTAN.sites$URL_str"},
			"list of CTAN mirrors"),
                      " (thanks!)." 
		      ),
		   )
		)
	      );

    $r->print(
	      end_CTAN_page(", revised 2001-Mar-02 JH.",$URL_str)
	      );

    return OK;
}

1;





