package Apache::MissingFile;
# file: Apache/MissingFile.pm

use strict;
use Apache::Constants qw(:common);
use CGI qw(:html);

sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;

    my $original_request = $r->prev;
    my $original_uri = $original_request ? $original_request->uri : '';
    # my $admin = $r->server->server_admin;

    $r->print(
	      start_html(-title => 'CTAN Material not found'),
	      h1('Requested material not found'),
	      p(
		"Sorry, but the material that you requested as ",
		strong($original_uri),
		" could not be found on CTAN. ",
		"Perhaps the ",
		a({-href => "http://www.ctan.org"},"top page"),
		" or the ",
		a({-href => "http://www.ctan.org/search"},"search page"),
                "would help you. ",
                "Or, perhaps you would like to ",
		a({-href => "http://www.ctan.org/tex-archive"},"browse"),
                "through the archive. "
		),
	      hr,
	      address(a({-href => "http://www.ctan.org/contacts.html"},"CTAN contact information")),
	      end_html
	      );
    return OK;
}

1;
__END__
