package Apache::Starter;
# File: Apache/Starter.pm

use strict;

use Apache::Constants qw(:common);
use CGI qw(:all);
use Apache::CTAN;

# all variables global to stop memory/GC buildup?
use vars qw(%cookie_data %param_data %except);
%cookie_data = ();
%param_data = ();
%except = (    # Do not include in the lists of params (e.g. in URL_str) 
	  );
use vars qw($header $redirect_flag $URL_str);
$header = "";  # http header that will be sent
$redirect_flag = 0; # should redirect to another page?
$URL_str = "";  # params as URL fields for a GET link

# Variable needed here, but not other modules
use vars qw($this_mods_URL $mirror);
$this_mods_URL = STARTER_PAGE(); # URL from perl.conf for this module  
$mirror = "";

use vars qw($r);  # request object

sub handler {
    $r = shift;
    # blank out cross-process data
    %cookie_data = ();
    %param_data = ();
    %except = (
	       );
    # handle http headers
    $param_data{PARAM_ACTION_KEY()} = $this_mods_URL;
    ($header,$redirect_flag) = CTAN_header($this_mods_URL,0,\%cookie_data,\%param_data);
    $r->print(
	      $header
	      );
    if ($redirect_flag) {
	return OK;
    }
    $URL_str = params_as_URLfields(%cookie_data,%param_data);
    # $mirror = $param_data{PARAM_MIRROR_KEY()};
    $param_data{PARAM_NEWMIRRORFLAG_KEY()} = 0;
    # done with the header & state stuff

    $r->print(
	      start_html(-title => "TeX starter page",
			 -meta=>{'keywords'=>META_KEYWORDS()}),
	      h2("TeX starter page")
	      );

    $r->print(
	      p(
		"If you are new to TeX and friends, welcome!
                 This page answers a few questions about how to get started."
		)
	      );

    $r->print(
	      p(
		ul(
		   li(
		      i("What documents are there that can help me?"),
		      " Most beginners seem to use the LaTeX package
                      and ",
		      a({-href=>WEBFTP_ROOT()."info/lshort/english/lshort.pdf$URL_str"},
			i("The (Not So) Short Introduction to LaTeX2e")),
		      "will take you a good way. ",
		      " If you will work in plain TeX, ",
		      a({-href=>WEBFTP_ROOT()."info/gentle/gentle.pdf$URL_str"},
			i("A Gentle Introduction to TeX")),
		      " is a classic. ",
		      "In addition, most academic libraries have a selection 
                      from the many fine books that are available."
		      ),
		   li(
		      i("Where can I get a TeX implementation?"),
		      " The ",
		      a({-href=>"http://www.tug.org/interest.html"},
			"Tex Users Group interest page"), 
		      "has a list of implementations, 
                       both free and commercial, 
                       for most platforms,
                       including win32 systems such as Windows 95 and NT. "
		      ),
		   li(
		      i("I want a particular package on CTAN, where should I look?"),
		      " Try the ",
		      a({-href=>SEARCH_PAGE()."$URL_str"},
			"search"),
		      " page. ",
		      " It also contains a few other ways to get information,
                       such as FAQ's."
		      ),
		   li(
		      i("If I get stuck on something, where can I look for help?"),
		      " A great resource for questions is the usenet 
                      discussion group comp.text.tex.
                      If you do not have a usenet feed, try ",
		      a({-href=>"http://www.deja.com"},
			"deja.com"),
		      " which allows you to search the archives of this group.
                      If searching doesn't help you, try posting.
                      It is a very friendly group. "
		      ),
		   )
		)
	      );

    $r->print(
	      end_CTAN_page(", revised 2001-Mar-02 JH.",$URL_str)
	      );

    return OK;
}

1;





